
#line 623 "nuweb.w"
#include "global.h"

#line 1636 "nuweb.w"
static void copy_scrap(FILE *file);     /* formats the body of a scrap */
static void display_scrap_ref(FILE *html_file, int num);
     /* formats a scrap reference */
static void display_scrap_numbers(FILE *html_file, Scrap_Node *scraps);
     /* formats a list of scrap numbers */
static void print_scrap_numbers(FILE *html_file, Scrap_Node *scraps);
     /* pluralizes scrap formats list */
static void format_entry(Name *name, FILE *html_file, int file_flag);
     /* formats an index entry */
static void format_user_entry(Name *name, FILE *html_file);

#line 1654 "nuweb.w"
void write_html(char *file_name, char *html_name)
{
  FILE *html_file = fopen(html_name, "w");
  if (html_file) {
    if (verbose_flag)
      fprintf(stderr, "writing %s\n", html_name);
    source_open(file_name);
    
#line 1677 "nuweb.w"
    {
      int scraps = 1;
      int c = source_get();
      while (c != EOF) {
        if (c == '@')
          
#line 1693 "nuweb.w"
          {
            c = source_get();
            switch (c) {
              case 'O':
              case 'o': 
#line 1754 "nuweb.w"
                        {
                          Name *name = collect_file_name();
                          
#line 1804 "nuweb.w"
                          {
                            if (hw_flag) fputs("\\begin{rawhtml}\n", html_file);
                            fputs("<pre>\n", html_file);
                          }
                          
#line 1756 "nuweb.w"
                        
                          
#line 1767 "nuweb.w"
                            fputs("<a name=\"nuweb", html_file);
                            write_single_scrap_ref(html_file, scraps);
                            fprintf(html_file, "\"><code>\"%s\"</code> ", name->spelling);
                            write_single_scrap_ref(html_file, scraps);
                            fputs("</a> =\n", html_file);
                          
#line 1757 "nuweb.w"
                        
                          scraps++;
                          
#line 1814 "nuweb.w"
                          {
                            copy_scrap(html_file);
                            fputs("&lt;&gt;</pre>\n", html_file);
                          }
                          
#line 1759 "nuweb.w"
                        
                          
#line 1836 "nuweb.w"
                          {
                            if (name->defs->next) {
                              fputs("File defined by ", html_file);
                              print_scrap_numbers(html_file, name->defs);
                              fputs("<br>\n", html_file);
                            }
                          }
                          
#line 1760 "nuweb.w"
                        
                          
#line 1825 "nuweb.w"
                          {
                            if (hw_flag) fputs("\\end{rawhtml}\n", html_file);
                            c = source_get(); /* Get rid of current at command. */
                          }
                          
#line 1761 "nuweb.w"
                        
                        }
                        
#line 1697 "nuweb.w"
          
                        break;
              case 'D':
              case 'd': 
#line 1776 "nuweb.w"
                        {
                          Name *name = collect_macro_name();
                          
#line 1804 "nuweb.w"
                          {
                            if (hw_flag) fputs("\\begin{rawhtml}\n", html_file);
                            fputs("<pre>\n", html_file);
                          }
                          
#line 1778 "nuweb.w"
                        
                          
#line 1795 "nuweb.w"
                            fputs("<a name=\"nuweb", html_file);
                            write_single_scrap_ref(html_file, scraps);
                            fprintf(html_file, "\">&lt;%s ", name->spelling);
                            write_single_scrap_ref(html_file, scraps);
                            fputs("&gt;</a> =\n", html_file);
                          
#line 1779 "nuweb.w"
                        
                          scraps++;
                          
#line 1814 "nuweb.w"
                          {
                            copy_scrap(html_file);
                            fputs("&lt;&gt;</pre>\n", html_file);
                          }
                          
#line 1781 "nuweb.w"
                        
                          
#line 1847 "nuweb.w"
                          {
                            if (name->defs->next) {
                              fputs("Macro defined by ", html_file);
                              print_scrap_numbers(html_file, name->defs);
                              fputs("<br>\n", html_file);
                            }
                          }
                          
#line 1782 "nuweb.w"
                        
                          
#line 1858 "nuweb.w"
                          {
                            if (name->uses) {
                              fputs("Macro referenced in ", html_file);
                              print_scrap_numbers(html_file, name->uses);
                            }
                            else {
                              fputs("Macro never referenced.\n", html_file);
                              fprintf(stderr, "%s: <%s> never referenced.\n",
                                      command_name, name->spelling);
                            }
                            fputs("<br>\n", html_file);
                          }
                          
#line 1783 "nuweb.w"
                        
                          
#line 1825 "nuweb.w"
                          {
                            if (hw_flag) fputs("\\end{rawhtml}\n", html_file);
                            c = source_get(); /* Get rid of current at command. */
                          }
                          
#line 1784 "nuweb.w"
                        
                        }
                        
#line 1700 "nuweb.w"
          
                        break;
              case 'f': 
#line 2000 "nuweb.w"
                        {
                          if (file_names) {
                            if (hw_flag) fputs("\\begin{rawhtml}\n", html_file);
                            fputs("<dl compact>\n", html_file);
                            format_entry(file_names, html_file, TRUE);
                            fputs("</dl>\n", html_file);
                            if (hw_flag) fputs("\\end{rawhtml}\n", html_file);
                          }
                          c = source_get();
                        }
                        
#line 1702 "nuweb.w"
          
                        break;
              case 'm': 
#line 2015 "nuweb.w"
                        {
                          if (macro_names) {
                            if (hw_flag) fputs("\\begin{rawhtml}\n", html_file);
                            fputs("<dl compact>\n", html_file);
                            format_entry(macro_names, html_file, FALSE);
                            fputs("</dl>\n", html_file);
                            if (hw_flag) fputs("\\end{rawhtml}\n", html_file);
                          }
                          c = source_get();
                        }
                        
#line 1704 "nuweb.w"
          
                        break;
              case 'u': 
#line 2094 "nuweb.w"
                        {
                          if (user_names) {
                            if (hw_flag) fputs("\\begin{rawhtml}\n", html_file);
                            fputs("<dl compact>\n", html_file);
                            format_user_entry(user_names, html_file);
                            fputs("</dl>\n", html_file);
                            if (hw_flag) fputs("\\end{rawhtml}\n", html_file);
                          }
                          c = source_get();
                        }
                        
#line 1706 "nuweb.w"
          
                        break;
              case '@': putc(c, html_file);
              default:  c = source_get();
                        break;
            }
          }
          
#line 1682 "nuweb.w"
    
        else {
          putc(c, html_file);
          c = source_get();
        }
      }
    }
    
#line 1661 "nuweb.w"

    fclose(html_file);
  }
  else
    fprintf(stderr, "%s: can't open %s\n", command_name, html_name);
}

#line 1874 "nuweb.w"
static void display_scrap_ref(FILE *html_file, int num)
{
  fputs("<a href=\"#nuweb", html_file);
  write_single_scrap_ref(html_file, num);
  fputs("\">", html_file);
  write_single_scrap_ref(html_file, num);
  fputs("</a>", html_file);
}

#line 1886 "nuweb.w"
static void display_scrap_numbers(FILE *html_file, Scrap_Node *scraps)
{
  display_scrap_ref(html_file, scraps->scrap);
  scraps = scraps->next;
  while (scraps) {
    fputs(", ", html_file);
    display_scrap_ref(html_file, scraps->scrap);
    scraps = scraps->next;
  }
}

#line 1900 "nuweb.w"
static void print_scrap_numbers(FILE *html_file, Scrap_Node *scraps)
{
  fputs("scrap", html_file);
  if (scraps->next) putc('s', html_file);
  putc(' ', html_file);
  display_scrap_numbers(html_file, scraps);
  fputs(".\n", html_file);
}

#line 1917 "nuweb.w"
static void copy_scrap(FILE *file)
{
  int indent = 0;
  int c = source_get();
  while (1) {
    switch (c) {
      case '@':  
#line 1950 "nuweb.w"
                 {
                   c = source_get();
                   switch (c) {
                     case '@': putc(c, file);
                               break;
                     case '|': 
#line 1412 "nuweb.w"
                               {
                                 do {
                                   do
                                     c = source_get();
                                   while (c != '@');
                                   c = source_get();
                                 } while (c != '}');
                               }
                               
#line 1955 "nuweb.w"
                 
                     case '}': return;
                     case '<': 
#line 1970 "nuweb.w"
                               {
                                 Name *name = collect_scrap_name();
                                 fprintf(file, "&lt;%s ", name->spelling);
                                 if (name->defs)
                                   
#line 1987 "nuweb.w"
                                   {
                                     Scrap_Node *p = name->defs;
                                     display_scrap_ref(file, p->scrap);
                                     if (p->next)
                                       fputs(", ... ", file);
                                   }
                                   
#line 1974 "nuweb.w"
                               
                                 else {
                                   putc('?', file);
                                   fprintf(stderr, "%s: scrap never defined <%s>\n",
                                           command_name, name->spelling);
                                 }
                                 fputs("&gt;", file);
                               }
                               
#line 1957 "nuweb.w"
                 
                               break;
                     default:  /* ignore these since pass1 will have warned about them */
                               break;
                   }
                 }
                 
#line 1923 "nuweb.w"

                 break;
      case '<' : fputs("&lt;", file);
                 indent++;
                 break;
      case '>' : fputs("&gt;", file);
                 indent++;
                 break;
      case '&' : fputs("&amp;", file);
                 indent++;
                 break;
      case '\n': putc(c, file);
                 indent = 0;
                 break;
      case '\t': 
#line 1382 "nuweb.w"
                 {
                   int delta = 8 - (indent % 8);
                   indent += delta;
                   while (delta > 0) {
                     putc(' ', file);
                     delta--;
                   }
                 }
                 
#line 1937 "nuweb.w"

                 break;
      default:   putc(c, file);
                 indent++;
                 break;
    }
    c = source_get();
  }
}

#line 2030 "nuweb.w"
static void format_entry(Name *name, FILE *html_file, int file_flag)
{
  while (name) {
    format_entry(name->llink, html_file, file_flag);
    
#line 2043 "nuweb.w"
    {
      fputs("<dt> ", html_file);
      if (file_flag) {
        fprintf(html_file, "<code>\"%s\"</code>\n<dd> ", name->spelling);
        
#line 2062 "nuweb.w"
        {
          fputs("Defined by ", html_file);
          print_scrap_numbers(html_file, name->defs);
        }
        
#line 2047 "nuweb.w"
    
      }
      else {
        fprintf(html_file, "&lt;%s ", name->spelling);
        
#line 2070 "nuweb.w"
        {
          if (name->defs)
            display_scrap_numbers(html_file, name->defs);
          else
            putc('?', html_file);
        }
        
#line 2051 "nuweb.w"
    
        fputs("&gt;\n<dd> ", html_file);
        
#line 2080 "nuweb.w"
        {
          Scrap_Node *p = name->uses;
          if (p) {
            fputs("Referenced in ", html_file);
            print_scrap_numbers(html_file, p);
          }
          else
            fputs("Not referenced.\n", html_file);
        }
        
#line 2053 "nuweb.w"
    
      }
      putc('\n', html_file);
    }
    
#line 2034 "nuweb.w"

    name = name->rlink;
  }
}

#line 2109 "nuweb.w"
static void format_user_entry(Name *name, FILE *html_file)
{
  while (name) {
    format_user_entry(name->llink, html_file);
    
#line 2122 "nuweb.w"
    {
      Scrap_Node *uses = name->uses;
      if (uses) {
        Scrap_Node *defs = name->defs;
        fprintf(html_file, "<dt><code>%s</code>:\n<dd> ", name->spelling);
        if (uses->scrap < defs->scrap) {
          display_scrap_ref(html_file, uses->scrap);
          uses = uses->next;
        }
        else {
          if (defs->scrap == uses->scrap)
            uses = uses->next;
          fputs("<strong>", html_file);
          display_scrap_ref(html_file, defs->scrap);
          fputs("</strong>", html_file);
          defs = defs->next;
        }
        while (uses || defs) {
          fputs(", ", html_file);
          if (uses && (!defs || uses->scrap < defs->scrap)) {
            display_scrap_ref(html_file, uses->scrap);
            uses = uses->next;
          }
          else {
            if (uses && defs->scrap == uses->scrap)
              uses = uses->next;
            fputs("<strong>", html_file);
            display_scrap_ref(html_file, defs->scrap);
            fputs("</strong>", html_file);
            defs = defs->next;
          }
        }
        fputs(".\n", html_file);
      }
    }
    
#line 2113 "nuweb.w"

    name = name->rlink;
  }
}
