
#line 615 "nuweb.w"
#include "global.h"

#line 1129 "nuweb.w"
static void copy_scrap(FILE *file);             /* formats the body of a scrap */
static int print_scrap_numbers(FILE *tex_file, Scrap_Node *scraps);
     /* formats a list of scrap numbers */
static void format_entry(Name *name, FILE *tex_file, int file_flag);
     /* formats an index entry */
static void format_user_entry(Name *name, FILE *tex_file);

#line 1142 "nuweb.w"
void write_tex(char *file_name, char *tex_name)
{
  FILE *tex_file = fopen(tex_name, "w");
  if (tex_file) {
    if (verbose_flag)
      fprintf(stderr, "writing %s\n", tex_name);
    source_open(file_name);
    
#line 1163 "nuweb.w"
    {
      int scraps = 1;
      int c = source_get();
      while (c != EOF) {
        if (c == '@')
          
#line 1179 "nuweb.w"
          {
            int big_definition = FALSE;
            c = source_get();
            switch (c) {
              case 'O': big_definition = TRUE;
              case 'o': 
#line 1244 "nuweb.w"
                        {
                          Name *name = collect_file_name();
                          if (!number_flag) fprintf(tex_file, "\\label{scrap%d}\n", scraps);
                          if (!big_definition) fputs("\\begin{nuwebfile}", tex_file);
                          else fputs("\\begin{nuwebbigfile}", tex_file);
                          fprintf(tex_file, "{%s}{", name->spelling);
                          write_single_scrap_ref(tex_file, scraps++);
                          putc('}', tex_file);
                          
#line 1289 "nuweb.w"
                          if (name->defs->next) {
                            int nos = print_scrap_numbers(tex_file, name->defs);
                            fprintf(tex_file, "{%d}", nos);
                          }
                          else fputs("{}{0}", tex_file);
                          
#line 1252 "nuweb.w"
                        
                          fputs("{}{0}", tex_file);
                          putc('\n', tex_file);
                          copy_scrap(tex_file);
                          if (!big_definition) fputs("\\end{nuwebfile}\n", tex_file);
                          else fputs("\\end{nuwebbigfile}\n", tex_file);
                        }
                        
#line 1184 "nuweb.w"
          
                        c = source_get();
                        break;
              case 'D': big_definition = TRUE;
              case 'd': 
#line 1267 "nuweb.w"
                        {
                          Name *name = collect_macro_name();
                          if (!number_flag) fprintf(tex_file, " \\label{scrap%d}\n", scraps);
                          if (!big_definition) fputs("\\begin{nuwebmacro}", tex_file);
                          else fputs("\\begin{nuwebbigmacro}", tex_file);
                          fprintf(tex_file, "{%s}{", name->spelling);
                          write_single_scrap_ref(tex_file, scraps++);
                          putc('}', tex_file);
                          
#line 1289 "nuweb.w"
                          if (name->defs->next) {
                            int nos = print_scrap_numbers(tex_file, name->defs);
                            fprintf(tex_file, "{%d}", nos);
                          }
                          else fputs("{}{0}", tex_file);
                          
#line 1275 "nuweb.w"
                        
                          
#line 1298 "nuweb.w"
                          {
                            if (name->uses) {
                              if (name->uses->next) {
                                int nos = print_scrap_numbers(tex_file, name->uses);
                                fprintf(tex_file, "{%d}", nos);
                              }
                              else {
                                putc('{', tex_file);
                                write_single_scrap_ref(tex_file, name->uses->scrap);
                                fputs("}{1}", tex_file);
                              }
                            }
                            else {
                              fputs("{}{0}", tex_file);
                              fprintf(stderr, "%s: <%s> never referenced.\n",
                                      command_name, name->spelling);
                            }
                          }
                          
#line 1276 "nuweb.w"
                        
                          putc('\n', tex_file);
                          copy_scrap(tex_file);
                          if (!big_definition) fputs("\\end{nuwebmacro}\n", tex_file);
                          else fputs("\\end{nuwebbigmacro}\n", tex_file);
                        }
                        
#line 1188 "nuweb.w"
          
                        c = source_get();
                        break;
              case 'f': 
#line 1456 "nuweb.w"
                        {
                          if (file_names)
                            format_entry(file_names, tex_file, TRUE);
                          c = source_get();
                        }
                        
#line 1191 "nuweb.w"
          
                        break;
              case 'm': 
#line 1466 "nuweb.w"
                        {
                          if (macro_names)
                            format_entry(macro_names, tex_file, FALSE);
                          c = source_get();
                        }
                        
#line 1193 "nuweb.w"
          
                        break;
              case 'u': 
#line 1553 "nuweb.w"
                        {
                          if (user_names)
                            format_user_entry(user_names, tex_file);
                          c = source_get();
                        }
                        
#line 1195 "nuweb.w"
          
                        break;
              case '@': putc(c, tex_file);
              default:  c = source_get();
                        break;
            }
          }
          
#line 1168 "nuweb.w"
    
        else {
          putc(c, tex_file);
          c = source_get();
        }
      }
    }
    
#line 1149 "nuweb.w"

    fclose(tex_file);
  }
  else
    fprintf(stderr, "%s: can't open %s\n", command_name, tex_name);
}

#line 1324 "nuweb.w"
static int print_scrap_numbers(FILE *tex_file, Scrap_Node *scraps)
{
  int page, nos = 0;
  putc('{', tex_file);
  write_scrap_ref(tex_file, scraps->scrap, TRUE, &page);
  scraps = scraps->next;
  nos++;
  while (scraps) {
    write_scrap_ref(tex_file, scraps->scrap, FALSE, &page);
    scraps = scraps->next;
    nos++;
  }
  putc('}', tex_file);
  return nos;
}

#line 1346 "nuweb.w"
static void copy_scrap(FILE *file)
{
  int indent = 0;
  int c = source_get();
  while (1) {
    switch (c) {
      case '@':  
#line 1394 "nuweb.w"
                 {
                   c = source_get();
                   switch (c) {
                     case '@': putc('@', file);
                               break;
                     case '|': 
#line 1412 "nuweb.w"
                               {
                                 do {
                                   do
                                     c = source_get();
                                   while (c != '@');
                                   c = source_get();
                                 } while (c != '}');
                               }
                               
#line 1399 "nuweb.w"
                 
                     case '}': return;
                     case '<': 
#line 1425 "nuweb.w"
                               {
                                 Name *name = collect_scrap_name();
                                 fprintf(file, "\\nuwebmacroname{%s}{", name->spelling);
                                 if (name->defs)
                                   
#line 1442 "nuweb.w"
                                   {
                                     Scrap_Node *p = name->defs;
                                     write_single_scrap_ref(file, p->scrap);
                                     p = p->next;
                                     if (p)
                                       fputs(",\\dots", file);
                                   }
                                   
#line 1429 "nuweb.w"
                               
                                 else {
                                   putc('?', file);
                                   fprintf(stderr, "%s: scrap never defined <%s>\n",
                                           command_name, name->spelling);
                                 }
                                 putc('}', file);
                               }
                               
#line 1401 "nuweb.w"
                 
                               break;
                   }
                 }
                 
#line 1352 "nuweb.w"

                 break;
      case '\t': 
#line 1382 "nuweb.w"
                 {
                   int delta = 8 - (indent % 8);
                   indent += delta;
                   while (delta > 0) {
                     putc(' ', file);
                     delta--;
                   }
                 }
                 
#line 1354 "nuweb.w"

                 break;
      case '\n': c = source_get();
                 if (!skipnl_flag || c != '@' ||
                     (source_next() != '|' && source_next() != '}')) {
                   putc('\n', file);
                   indent = 0;
                 }
                 continue;
      case '{':
      case '}':
      case '\\': fprintf(file, "\\verb!%c!", c);
                 break;
      default:   putc(c, file);
                 indent++;
                 break;
    }
    c = source_get();
  }
}

#line 1476 "nuweb.w"
static void format_entry(Name *name, FILE *tex_file, int file_flag)
{
  while (name) {
    format_entry(name->llink, tex_file, file_flag);
    
#line 1489 "nuweb.w"
    {
      fputs("\\item ", tex_file);
      if (file_flag) {
        fprintf(tex_file, "\\verb@\"%s\"@, ", name->spelling);
        
#line 1508 "nuweb.w"
        {
          Scrap_Node *p = name->defs;
          if (p->next)
            print_scrap_numbers(tex_file, p);
          else
            write_single_scrap_ref(tex_file, p->scrap);
        }
        
#line 1493 "nuweb.w"
    
      }
      else {
        fprintf(tex_file, "\\(\\langle\\)%s, ", name->spelling);
        
#line 1519 "nuweb.w"
        {
          Scrap_Node *p = name->defs;
          if (p) {
            int page;
            write_scrap_ref(tex_file, p->scrap, TRUE, &page);
            p = p->next;
            while (p) {
              write_scrap_ref(tex_file, p->scrap, FALSE, &page);
              p = p->next;
            }
          }
          else
            putc('?', tex_file);
        }
        
#line 1497 "nuweb.w"
    
        fputs("\\(\\rangle\\) ", tex_file);
        
#line 1537 "nuweb.w"
        {
          Scrap_Node *p = name->uses;
          if (p) {
            if (p->next)
              print_scrap_numbers(tex_file, p);
            else
              write_single_scrap_ref(tex_file, p->scrap);
          }
          else
            fputs("\\textbf{not referenced}", tex_file);
        }
        
#line 1499 "nuweb.w"
    
      }
      putc('\n', tex_file);
    }
    
#line 1480 "nuweb.w"

    name = name->rlink;
  }
}

#line 1563 "nuweb.w"
static void format_user_entry(Name *name, FILE *tex_file)
{
  while (name) {
    format_user_entry(name->llink, tex_file);
    
#line 1576 "nuweb.w"
    {
      Scrap_Node *uses = name->uses;
      if (uses) {
        int page;
        Scrap_Node *defs = name->defs;
        fprintf(tex_file, "\\item \\verb@%s@, ", name->spelling);
        if (uses->scrap < defs->scrap) {
          write_scrap_ref(tex_file, uses->scrap, TRUE, &page);
          uses = uses->next;
        }
        else {
          if (defs->scrap == uses->scrap)
            uses = uses->next;
          fputs("\\underline{", tex_file);
          write_single_scrap_ref(tex_file, defs->scrap);
          putc('}', tex_file);
          page = -2;
          defs = defs->next;
        }
        while (uses || defs) {
          if (uses && (!defs || uses->scrap < defs->scrap)) {
            write_scrap_ref(tex_file, uses->scrap, FALSE, &page);
            uses = uses->next;
          }
          else {
            if (uses && defs->scrap == uses->scrap)
              uses = uses->next;
            fputs(", \\underline{", tex_file);
            write_single_scrap_ref(tex_file, defs->scrap);
            putc('}', tex_file);
            page = -2;
            defs = defs->next;
          }
        }
        fputs("\n", tex_file);
      }
    }
    
#line 1567 "nuweb.w"

    name = name->rlink;
  }
}
